<!-- eslint-disable vue/no-v-html -->
<template>
  <div
    class="form-control form-control-flush"
    :class="{
      'cursor-not-allowed': project.state.slug === 'running',
    }"
  >
    <client-only placeholder="loading...">
      <a
        data-cy="link-to-open-qf"
        :class="{
          'disabled-action': project.state.slug === 'running',
        }"
        @click.stop="showQueryFactory()"
      >
        <span
          v-if="!isEmptyQuery(param.value)"
          class="text-break small cursor-pointer"
          v-html="getHumanReadableQuery(JSON.parse(param.value) || undefined)"
        ></span>
        <span v-else class="font-italic text-indigo small cursor-pointer"
          ><TableShortcutIcon class="icon-xxs" />
          {{
            param.placeholder ? param.placeholder : 'Open the query factory...'
          }}</span
        >
      </a>
      <vue-final-modal
        v-model="show"
        classes="modal-container"
        content-class="modal-content"
        :name="getQueryFactoryModalName()"
      >
        <template #title>$vfm.show</template>
        <template #default="{ params }">
          <a
            class="btn btn-icon btn-close query-factory-modal-close"
            @click="show = false"
          >
            <XIcon class="icon-xxs" />
          </a>
          <span class="query-factory-modal-title pb-2"
            ><TableAliasIcon class="icon" /> {{ params.title }}</span
          >
          <div class="query-factory-modal-content">
            <div
              class="query-factory-modal-header sticky-top m-0 pt-2 pl-1 pr-1 pb-2"
            >
              <b-container class="h-100 m-0" fluid="xl">
                <b-row
                  class="h-100"
                  align-h="start"
                  align-v="stretch"
                  no-gutters
                >
                  <b-col class="h-100 w-100 p-0">
                    <template v-if="isEmptyQueryObject(query)">
                      <pre
                        class="p-0 m-0 h-100 text-wrap rounded-0"
                        style="overflow: hidden"
                      >
                        <code class="w-100 h-100 text-muted d-flex justify-content-center align-items-center h-100 font-italic">
                          <InfoCircleIcon class="icon-xss mr-1" />
                          <span>Start by selecting a <span class="strong">field</span> and click on <span class="strong">Rule</span></span>
                        </code>
                      </pre>
                    </template>
                    <template v-else>
                      <pre
                        class="p-0 m-0 h-100 text-wrap rounded-0"
                        style="overflow: hidden"
                      >
                        <code class="w-100 h-100">
                          <div class="query-factory-code" v-html="getHumanReadableQuery(query)"></div>
                        </code>
                    </pre>
                    </template>
                  </b-col>
                  <b-col cols="2" class="h-100 w-100 p-0">
                    <div
                      class="btn-group-vertical rounded-0 h-100 w-100"
                      role="group"
                    >
                      <QueryFactoryModalPresets
                        :load-query-string="loadQueryString"
                        :rsml-input-parameter="param"
                      />
                      <div
                        class="btn-group dropdown input-group-append w-100 h-100"
                        role="group"
                      >
                        <button type="button" class="btn p-0 rounded-0">
                          <CircleCheckIcon
                            v-if="isCompletedQuery(query)"
                            class="text-green p-0 m-0"
                          />
                          <CircleOffIcon v-else class="text-pink p-0 m-0" />
                        </button>
                        <button
                          ref="copyBtn"
                          type="button"
                          class="btn p-0 rounded-0"
                          data-toggle="tooltip"
                          data-placement="bottom"
                          title="Copy to clipboard"
                        >
                          <CopyIcon
                            class="text-black p-0 m-0"
                            @click="copyQueryToClipboard"
                          />
                        </button>
                        <button
                          v-b-modal.modal-create-preset
                          type="button"
                          class="btn p-0 rounded-0"
                          data-cy="create-preset-btn"
                          :disabled="!isCompletedQuery(query)"
                        >
                          <DeviceFloppyIcon
                            class="text-black p-0 m-0"
                            aria-disabled="true"
                          />
                        </button>
                        <ModalsCreatePreset
                          v-if="query"
                          id="modal-create-preset"
                          :header="false"
                          :footer="false"
                          :query="JSON.stringify(leanQuery)"
                        />
                        <button
                          v-b-tooltip.hover.top="{ variant: 'dark' }"
                          type="button"
                          class="btn p-0 rounded-0"
                          :disabled="!userPresetSelected"
                          :title="
                            userPresetSelected ? userPresetSelected.label : ''
                          "
                          @click="confirmDeletePreset()"
                        >
                          <TrashIcon
                            class="text-danger p-0 m-0"
                            aria-disabled="true"
                          />
                        </button>
                      </div>
                    </div>
                  </b-col>
                </b-row>
              </b-container>
            </div>
            <div class="query-factory-modal-body m-0 pt-2 pl-1 pr-1 pb-2">
              <b-container class="h-100 m-0" fluid="xl">
                <b-row
                  class="h-100"
                  align-h="start"
                  align-v="stretch"
                  no-gutters
                >
                  <b-col class="h-100 w-100 p-0">
                    <query-builder v-model="query" :config="config">
                      <template #groupOperator="props">
                        <group-operator-slot :group-operator="props" />
                      </template>

                      <template #groupControl="props">
                        <group-ctrl-slot
                          :rsml-input-parameter="param"
                          :group-ctrl="props"
                        />
                      </template>

                      <template #rule="props">
                        <rule-slot :rules="config.rules" :rule-ctrl="props" />
                      </template>
                    </query-builder>
                  </b-col>
                </b-row>
              </b-container>
            </div>
          </div>
          <div class="query-factory-modal-footer pt-3 pr-3">
            <b-button
              class="btn btn-purple mr-1"
              data-cy="btn-update-qf"
              :disabled="!isCompletedQuery(query)"
              @click.stop="
                updateInput();
                show = false;
              "
            >
              <RefreshIcon class="icon-xxs" /> Update
            </b-button>
            <a class="btn ml-1" @click="show = false">
              <LogoutIcon class="icon-xxs" /> Cancel
            </a>
          </div>
        </template>
      </vue-final-modal>
    </client-only>
  </div>
</template>
<script>
import Vue from 'vue';
import { vfmPlugin } from 'vue-final-modal';
import { mapGetters } from 'vuex';
import GroupOperatorSlot from '../../../../components/QueryFactoryGroupOperatorSlot';
import GroupCtrlSlot from '../../../../components/QueryFactoryGroupCtrlSlot';
import RuleSlot from '../../../../components/QueryFactoryRuleSlot';
import queryFactoryConstants from '../../../constants/queryFactory';
import QueryFactoryModalPresets from '../../../../components/QueryFactoryModalPresets';
import QueryFactoryInput from './QueryFactoryInput.vue';
import notificationsMixin from '~/mixins/notifications.js';
Vue.use(
  vfmPlugin({
    key: '$vfm',
    componentName: 'VueFinalModal',
    dynamicContainerName: 'ModalsContainer',
  })
);
export default {
  components: {
    [process.client && 'QueryBuilder']: () => import('query-builder-vue'),
    GroupOperatorSlot,
    GroupCtrlSlot,
    RuleSlot,
    QueryFactoryModalPresets,
  },
  mixins: [notificationsMixin],
  props: {
    parameter: {
      type: Object,
      default: () => {},
    },
    disabled: {
      type: Boolean,
      default: () => false,
    },
    updateValue: {
      type: Function,
      default: () => ({}),
    },
  },
  data() {
    return {
      projectId: this.$nuxt.$route.params.id,
      scenarioId: this.$nuxt.$route.params.scenarioId,
      QueryFactory: null,
      show: false,
      dragging: true,
      query: null,
    };
  },
  computed: {
    ...mapGetters({
      userPresetSelected: 'presets/getUserPreset',
    }),
    project() {
      return this.$store.getters['projects/singleProject'](this.projectId);
    },
    modalCreatePreset() {
      const modalData =
        this.$nuxt.context.store.getters['ui/createPresetModal'];
      return modalData.visible;
    },
    leanQuery() {
      return this.getLeanQuery(this.query);
    },
    param() {
      return this.$nuxt.context.store.state.parameters.inputMap[
        this.parameter.key
      ];
    },
    config() {
      return {
        colors: ['#6574cd', '#b8afcb'],
        dragging: {
          animation: 300,
          disabled: !this.dragging,
          dragClass: 'query-factory-rules-sortable-drag',
        },
        operators: this.getQueryFactory().operators(),
        rules: this.getQueryFactory().rules(),
      };
    },
  },
  mounted() {
    // this.$watch('param.value', (value) => {
    // });
    this.$nextTick(() => {
      this.$refs.copyBtn.addEventListener('click', async () => {
        const isCopied = await this.copyQueryToClipboard();
        // eslint-disable-next-line no-empty
        if (isCopied) {
        }
      });
    });
  },
  created() {},
  methods: {
    async confirmDeletePreset() {
      await this.$bvModal
        .msgBoxConfirm(
          `Do you want to delete the preset ${this.userPresetSelected.label}?`,
          {
            id: 'delete-preset-modal',
            title: 'Delete preset',
            size: 'sm',
            buttonSize: 'sm',
            okVariant: 'danger',
            okTitle: 'Yes',
            cancelTitle: 'No',
            footerClass: 'p-2',
            hideHeaderClose: false,
            centered: true,
          }
        )
        .then(async (value) => {
          if (value) await this.deletePreset();
        });
    },
    async deletePreset() {
      const response = await this.$nuxt.context.store
        .dispatch('presets/deletePreset', {
          scenarioId: this.$nuxt.$route.params.scenarioId,
          presetId: this.userPresetSelected.presetId,
        })
        .catch(() => {
          this.showNotification(
            'Ops... The preset could not be deleted',
            'Error Deleting Preset',
            'danger'
          );
        });
      if (response) {
        this.showNotification(
          'The preset was deleted successfully',
          'Preset Deleted!'
        );
        this.$nuxt.context.store.commit('presets/setUserPreset', null);
        this.$nuxt.context.store.dispatch('presets/getPresets', {
          scenarioId: this.$nuxt.$route.params.scenarioId,
        });
      }
    },
    loadQueryString(queryStr) {
      if (typeof queryStr === 'object') {
        queryStr = JSON.stringify(queryStr);
      }
      const queryObj = this.parseQueryString(queryStr);
      if (queryObj) {
        this.query = queryObj;
      }
    },
    clearQuery() {
      this.query = null;
    },
    createPresetModalHidden() {
      this.$store.commit('ui/setCreatePresetVisible', false);
    },
    createPresetModalShown() {
      this.$store.commit('ui/setCreatePresetVisible', true);
    },
    async copyQueryToClipboard() {
      if (!this.query) return;
      try {
        const stringQuery = JSON.stringify(this.query);
        await navigator.clipboard.writeText(stringQuery);
        return true;
      } catch ($e) {
        return false;
      }
    },
    async updateInput() {
      if (this.disabled) return;
      await this.updateValue(
        this.parameter.key,
        JSON.stringify(this.leanQuery) || ''
      );
    },
    getQueryFactory() {
      const vm = this;
      function operators() {
        return queryFactoryConstants.operators;
      }
      function rules() {
        const datasets = vm?.param?.options?.properties?.datasets;
        if (typeof datasets === 'undefined') {
          // empty list of rules;
          return [{}];
        }
        // parsedRules
        const parsedRules = [];
        // loop sources
        for (const [sourceId, source] of Object.entries(datasets.sources)) {
          const entities = source?.options?.properties?.entities;
          const fields = source?.options?.properties?.fields;
          // only if we have fields
          if (typeof fields !== 'object' || fields === null) continue;
          // loop fields
          // note that fields are not nested within its parent entities, this is
          // the intended behavior
          for (const [id, prop] of Object.entries(fields)) {
            // parsedIdentifier
            const parsedIdentifier = vm.parseIdentifier(id);

            // matchedSourceId
            const matchedSourceId =
              parsedIdentifier.sourceId === sourceId
                ? parsedIdentifier.sourceId
                : undefined;

            // identifier didn't match the parent sourceId
            if (matchedSourceId === undefined) continue;

            // the expected entityId
            const entityId = `${parsedIdentifier.sourceId}.${parsedIdentifier.entityId}`;

            // entity
            const entity = entities[entityId] || undefined;

            // identifier didn't match the parent entityId
            if (entity === undefined) continue;

            // build currentRule
            const currentRule = {
              // sourceId
              sourceId: parsedIdentifier.sourceId,
              // entityId
              entityId: parsedIdentifier?.entityId,
              // fieldId
              fieldId: parsedIdentifier.fieldId,
              // identifier
              identifier: id,
              // name
              name: prop.title || id,
              // title
              ...(prop.title !== undefined && { title: prop.title }),
              // type
              type: prop?.type
                ? prop.type.replace(/^string\+/, '')
                : queryFactoryConstants.defaultInputType,
              // mode
              ...(prop.mode !== undefined && { mode: prop.mode }),
              // placeholder
              ...(prop.placeholder !== undefined && {
                placeholder: prop.placeholder,
              }),
              // hint
              ...(prop.hint !== undefined && { hint: prop.hint }),
              // description
              ...(prop.description !== undefined && {
                description: prop.description,
              }),
              // options
              ...(prop.options !== undefined && {
                options: prop.options,
              }),
              // component
              component: QueryFactoryInput,
            };

            // initialValue
            const initialValue = {
              // title
              ...(prop.title !== undefined && { title: prop.title }),
              // type
              ...(prop.type !== undefined && {
                type: prop.type.replace(/^string\+/, ''),
              }),
              // data
              ...(prop.default.data !== undefined && {
                data: prop.default.data,
              }),
              // condition
              ...(prop.default.condition !== undefined && {
                condition: prop.default.condition,
              }),
              // isDataCompleted
              isDataCompleted: prop?.default?.data || false,
            };

            // currentRule.initialValue
            currentRule.initialValue = () => ({
              ...initialValue,
            });

            // add the current rule to the list of parsed rules
            parsedRules.push(currentRule);
          }
        }
        return parsedRules;
      }
      return { operators, rules };
    },
    parseQueryString(queryStr) {
      if (!queryStr) {
        return null;
      }
      try {
        const queryObj = JSON.parse(queryStr);
        if (this.isEmptyQueryObject(queryObj)) {
          return null;
        }
        return queryObj;
      } catch ($e) {
        return null;
      }
    },
    isCompletedQuery(queryObj) {
      return (
        !this.isEmptyQueryObject(queryObj) &&
        this.isDataCompletedQueryObject(queryObj)
      );
    },
    isDataCompletedQueryObject(queryObj) {
      if (Array.isArray(queryObj)) {
        return queryObj.every(this.isDataCompletedQueryObject);
      } else if (typeof queryObj === 'object') {
        return (
          Object.values(queryObj).every(this.isDataCompletedQueryObject) &&
          (Object.prototype.hasOwnProperty.call(queryObj, 'isDataCompleted')
            ? queryObj.isDataCompleted
            : true)
        );
      } else {
        return true;
      }
    },
    isEmptyQueryObject(queryObj) {
      const emptyQueryObject =
        !queryObj || !('children' in queryObj) || !queryObj.children.length;
      return emptyQueryObject;
    },
    isEmptyQuery(queryStr) {
      return this.parseQueryString(queryStr) === null;
    },
    getLeanQuery(inputQuery) {
      const filterQueryProperties = (currentQuery, currentLeanQuery) => {
        for (const [key, value] of Object.entries(currentQuery)) {
          if (
            key === 'operatorIdentifier' ||
            key === 'identifier' ||
            key === 'value'
          ) {
            if (key === 'value') {
              currentLeanQuery[key] = {
                type: value.type,
                data: value.data,
                condition: value.condition,
                isDataCompleted: value.isDataCompleted,
              };
            } else {
              currentLeanQuery[key] = value;
            }
          }
          if (key === 'children' && Array.isArray(value)) {
            currentLeanQuery[key] = [];
            for (let i = 0; i < value.length; i++) {
              currentLeanQuery[key].push({});
              filterQueryProperties(value[i], currentLeanQuery[key][i]);
            }
          }
        }
        return currentLeanQuery;
      };
      const leanQueryResult = {};
      filterQueryProperties(inputQuery, leanQueryResult);
      return leanQueryResult;
    },
    getSafeQueryDataValue(value) {
      if (!(typeof value === 'string' || value instanceof String)) {
        return value;
      }

      if (!value || value === '') {
        return '';
      }

      // @source https://stackoverflow.com/a/7760578
      // eslint-disable-next-line no-control-regex,  no-useless-escape
      return value.replace(/[\0\x08\x09\x1A\n\r<>&"'\\\%]/g, function (char) {
        switch (char) {
          case '\0':
            return '\\0';
          case '\x08':
            return '\\b';
          case '\x09':
            return '\\t';
          case '\x1A':
            return '\\z';
          case '\n':
            return '\\n';
          case '\r':
            return '\\r';
          case '<':
            return '&lt;';
          case '>':
            return '&gt;';
          case '&':
            return '&amp;';
          case '"':
          case "'":
          case '\\':
          case '%':
            return '\\' + char;
        }
      });
    },
    parseIdentifier(identifier) {
      const parts = identifier.split('.');
      let result = {};

      if (parts.length === 1) {
        result = {
          sourceId: '',
          entityId: '',
          fieldId: parts[0],
        };
      } else if (parts.length === 2) {
        result = {
          sourceId: '',
          entityId: parts[0],
          fieldId: parts[1],
        };
      } else if (parts.length === 3) {
        result = {
          sourceId: parts[0],
          entityId: parts[1],
          fieldId: parts[2],
        };
      }
      return result;
    },
    toHumanReadable(
      query,
      decorator = {
        /* eslint-disable @typescript-eslint/no-unused-vars */
        identifier: (identifier) => identifier,
        condition: (condition) => condition,
        data: (data, _type, _isDataCompleted) => data,
        operator: (operator) => operator,
        /* eslint-enable @typescript-eslint/no-unused-vars */
      },
      isParent = true,
      operator = query.operatorIdentifier
    ) {
      let humanReadable = '';
      if (query.children) {
        let shouldIncludeParenthesis = !isParent && query.children.length > 1;
        if (operator === 'NOT_AND' || operator === 'NOT_OR') {
          if (query.children.length > 1) {
            shouldIncludeParenthesis = true;
          }
        }
        if (shouldIncludeParenthesis) {
          humanReadable += '(';
        }
        for (let i = 0; i < query.children.length; i++) {
          const child = query.children[i];
          let childValueData;
          if (child.value && 'data' in child.value) {
            childValueData = this.getSafeQueryDataValue(child.value.data);
          }
          if (child.operatorIdentifier) {
            humanReadable += this.toHumanReadable(child, decorator, false);
          } else if (
            (childValueData || childValueData === '') &&
            child.value.condition &&
            child.value.condition.humanOp
          ) {
            if (
              'cardinality' in child.value.condition &&
              child.value.condition.cardinality === 0
            ) {
              humanReadable += `${decorator.identifier(
                child.identifier
              )} ${decorator.condition(child.value.condition.humanOp)}`;
            } else if (child.value.type && child.value.type === 'number') {
              humanReadable += `${decorator.identifier(
                child.identifier
              )} ${decorator.condition(
                child.value.condition.humanOp
              )} ${decorator.data(
                childValueData,
                child.value.type,
                child.value.isDataCompleted,
                child.value.condition.id
              )}`;
            } else {
              humanReadable += `${decorator.identifier(
                child.identifier
              )} ${decorator.condition(
                child.value.condition.humanOp
              )} '${decorator.data(
                childValueData,
                child.value.type,
                child.value.isDataCompleted,
                child.value.condition.id
              )}'`;
            }
          } else if (
            typeof child.value === 'string' ||
            child.value instanceof String
          ) {
            childValueData = this.getSafeQueryDataValue(child.value);
            humanReadable += `${decorator.identifier(
              child.identifier
            )} = '${decorator.data(
              childValueData,
              'text',
              false,
              child.value.condition.id
            )}'`;
          } else if (
            typeof child.value === 'number' ||
            child.value instanceof Number
          ) {
            childValueData = this.getSafeQueryDataValue(child.value);
            humanReadable += `${decorator.identifier(
              child.identifier
            )} = '${decorator.data(
              childValueData,
              'number',
              false,
              child.value.condition.id
            )}'`;
          } else if (child.value.type === 'number') {
            humanReadable += `${decorator.identifier(child.identifier)}`;
          } else {
            humanReadable += `${decorator.identifier(child.identifier)} = ''`;
          }
          if (i < query.children.length - 1) {
            let childrenOperator = operator;
            if (operator === 'NOT_AND') {
              childrenOperator = 'AND';
            } else if (operator === 'NOT_OR') {
              childrenOperator = 'OR';
            }
            humanReadable += ` ${decorator.operator(childrenOperator)} `;
          }
        }
        if (shouldIncludeParenthesis) {
          humanReadable += ')';
        }
      }
      if (
        operator === 'NOT' ||
        operator === 'NOT_AND' ||
        operator === 'NOT_OR'
      ) {
        humanReadable = `${decorator.operator('NOT')} ${humanReadable}`;
      }
      return humanReadable;
    },
    getHumanReadableQuery(queryObj, useSyntaxHighlight = true) {
      if (!queryObj) {
        return '';
      }

      let humanReadableQueryString;

      if (useSyntaxHighlight) {
        const decorator = {
          identifier: (identifier) =>
            `<span title="${identifier}" class="text-indigo">${
              this.parseIdentifier(identifier).entityId
            }.${this.parseIdentifier(identifier).fieldId}
            </span>`,
          condition: (condition) =>
            `<span class="text-orange">${condition}</span>`,
          data: (data, type, isDataCompleted, conditionId) => {
            const classDataIncomplete = isDataCompleted
              ? ''
              : ' query-factory-field-incomplete';
            const iconDataIncomplete = isDataCompleted
              ? ''
              : '<i class="icon icon-tabler icon-tabler-package"></i>';
            const newData = ['between', 'not_between'].includes(conditionId)
              ? data.replace(',', ' AND ')
              : data;
            switch (type) {
              case 'number':
                return `<span class="text-pink${classDataIncomplete}">${iconDataIncomplete}${newData}</span>`;
              case 'text':
              default:
                return `<span class="text-green${classDataIncomplete}">${iconDataIncomplete}${newData}</span>`;
            }
          },
          operator: (operator) => `<span class="strong">${operator}</span>`,
        };
        humanReadableQueryString = this.toHumanReadable(queryObj, decorator);
      } else {
        humanReadableQueryString = this.toHumanReadable(queryObj);
      }
      return humanReadableQueryString;
    },
    getQueryFactoryModalName() {
      return 'query-factory-' + this.parameter.key;
    },
    showQueryFactory() {
      // always display the stored query when opening the query factory
      this.loadQueryString(this.param.value);
      // messy param* properties names
      // this.parameter: passed when creating a QueryFactory
      // this.param: local computed method given access to this.parameter.key attrs
      // params: allow to have access to this.param inside the modal
      // note that $vfm.show receives two arguments (name, params)
      this.$vfm
        .show(this.getQueryFactoryModalName(), this.param)
        .then(() => {});
    },
  },
};
</script>
<style scoped>
::v-deep .query-builder-group__group-selection {
  padding: 10rem;
  background-color: rgb(245, 247, 251) !important;
}

::v-deep .modal-container {
  display: flex;
  justify-content: center;
  align-items: center;
}

::v-deep .modal-container > .modal-content {
  position: relative;
  display: flex;
  flex-direction: column;
  max-height: 70%;
  min-height: 70%;
  max-width: 1038px;
  margin: 0 1rem;
  padding: 1rem;
  border: 1px solid #e2e8f0;
  border-radius: 0.25rem;
  background: #fff;
}

::v-deep div.query-builder-rule {
  padding: 0 0 0 1rem !important;
  background-color: rgb(255, 255, 255) !important;
}

::v-deep .query-builder-group__child:not(:last-child) {
  margin-bottom: 0 !important;
}
::v-deep .query-builder-group__child .query-builder-group__control {
  padding-left: 1em !important;
}
::v-deep .query-builder-group__group-children--depth-1 {
  margin-left: 0 !important;
}

::v-deep .query-builder-child__delete-child {
  /* top: 1em !important; */
  top: 0 !important;
}

.query-factory-modal-title {
  margin: 0 2rem 0 0;
  font-size: 1.14rem;
  font-weight: 700;
}

.query-factory-modal-header {
  height: 6em;
  background-color: rgb(255, 255, 255);
}

.query-factory-modal-footer {
  display: flex;
  justify-content: end;
  align-items: center;
  flex-shrink: 0;
  padding: 1rem 0 0;
}

.query-factory-modal-content {
  flex-grow: 1;
  overflow-y: auto;
}

.query-factory-modal-close {
  position: absolute;
  top: 0.5rem;
  right: 0.5rem;
}

.query-factory-code {
  padding: 0;
  margin: 7px 0 0 7px;
  font-size: 0.75rem;
}

.query-factory-rules-sortable-drag {
  transform: skewY(-2.5deg);
  opacity: 0.6;
}

::v-deep .query-factory-field-incomplete::before {
  content: '\2716';
  margin: 2px;
  font-size: 1em;
  color: #e81b41;
}

.sticky-top {
  top: 0;
}
</style>
